import time, random
from pygame.locals import *
from pygsear.Game import *
from pygsear.conf import *
from pygsear.Drawable import *
from pygsear.Widget import *
from pygsear.Cursor import *
from pygsear.Util import *
from pygsear.Event import KEYDOWN_Event, KEY_Event
from messages import *

from objects import *
from levels import *

conf.WINSIZE=(1024,768)
conf.MAX_FPS=30

try:
    pygame.mixer.init()
except:
    print "No audio available"

class Play(Game):
    def initialize(self):
        self.next_state = None
        self.set_title("PW6 - C.A.T.:B.O.T. (play)")
        self.moving_sprites=self.addGroup()
        self.still_sprites=self.addGroup()
        #curse=ImageCursor(filename=DCT_TILE["cratetarget1"])
        #self.hideMouse()
        #self.sprites.add(curse)
        self.query_events=self.addEventGroup()
        self.macro_events=self.addEventGroup()
        self.edit_events=self.addEventGroup()
        self.msglist=[]

        self.events.add(KEYDOWN_Event(key=K_f,callback=self.togl_fullscreen))
        self.set_background(filename=DCT_INT["bg"])

        self.page=0
        self.lvlnr=0
        self.aborted=False
        self.lst_lines = []
        self.lst_allLines = []
        self.macro_buttons = {}
        self.selection =  0
        self.macro_selection = 0
        self.inserting = False
        self.mode = "edit"
        self.catbot = CatBot(name="catbot")
        self.johnny = CatBot(name="johnny")
        self.evilguy= CatBot(name="evilguy")
        self.counter=0
        self.wait_counter=0

        self.dct_macros = {}
        self.dct_macros["f1"]=[]
        self.dct_macros["f2"]=[]
        self.dct_macros["f3"]=[]
        self.dct_macros["f4"]=[]
        self.dct_macros["f5"]=[]
        self.dct_macros["f6"]=[]
        self.dct_macros["f7"]=[]
        self.dct_macros["f8"]=[]
        self.dct_macros["f9"]=[]
        self.dct_macros["f10"]=[]

        linex = [35,232,430,628]
        for i in xrange(20):
            if not i%5:
                y=648
                x=linex.pop(0)

            a = Line(name="empty", callback=self.select)
            a.set_kwargs(i)
            a.set_position((x,y-3))
            self.lst_lines.append(a)
            self.edit_events.add(a.events)

            b = EditButton(name="down", callback=self.ln_move)
            b.set_kwargs([i, "down"])
            b.set_position((x+103,y))
            self.edit_events.add(b.events)

            c = EditButton(name="up", callback=self.ln_move)
            c.set_kwargs([i, "up"])
            c.set_position((x+118,y))
            self.edit_events.add(c.events)

            d = EditButton(name="ins", callback=self.ln_edit)
            d.set_kwargs([i, "ins"])
            d.set_position((x+133,y))
            self.edit_events.add(d.events)

            e = EditButton(name="del", callback=self.ln_edit)
            e.set_kwargs([i, "del"])
            e.set_position((x+148,y))
            self.edit_events.add(e.events)
            y += 19

        #draw command buttons
        y = 10
        x = 800
        y_offset = 21
        x,y = (867,225)
        f = FuncButton(name="fwd", callback=self.add_command)
        f.set_kwargs("fwd")
        f.set_position((x,y))
        y+=y_offset
        g = FuncButton(name="left", callback=self.add_command)
        g.set_kwargs("left")
        g.set_position((x,y))
        y+=y_offset
        h = FuncButton(name="right", callback=self.add_command)
        h.set_kwargs("right")
        h.set_position((x,y))
        y+=y_offset
        i = FuncButton(name="wait", callback=self.add_command)
        i.set_kwargs("wait")
        i.set_position((x,y))
        y+=y_offset
        j = FuncButton(name="push", callback=self.add_command)
        j.set_kwargs("push")
        j.set_position((x,y))
        y+=y_offset
        k = FuncButton(name="use", callback=self.add_command)
        k.set_kwargs("use")
        k.set_position((x,y))
        y+=y_offset
        l = FuncButton(name="pickup", callback=self.add_command)
        l.set_kwargs("pickup")
        l.set_position((x,y))
        self.edit_events.add([f.events, g.events, h.events, i.events, j.events,
                         k.events, l.events])
        y+=y_offset  #draw func buttons

        for i in xrange(10):
            l = MacroButton(name="f"+str(i+1), callback=self.add_command)
            l.set_kwargs("f"+str(i+1))
            l.set_callback2(callback2=self.edit_macro, kwargs2="f"+str(i+1))
            l.set_position((x,y))
            self.macro_buttons["f"+str(i+1)]=l
            self.edit_events.add(l.events)
            y+=y_offset

        m1 = FuncButton(name="menurun", callback=self.run_script)
        m1.set_position((863,668))
        m2 = FuncButton(name="menustop", callback=self.configure)
        m2.set_position((921,668))
        m3 = FuncButton(name="menuhelp", callback=self.show_help)
        m3.set_kwargs("menuhelp")
        m3.set_position((863,695))
        self.help_button=m3
        m4 = FuncButton(name="menuexit", callback=self.start_menu)
        m4.set_position((921,695))

        self.edit_events.add([m1.events,m2.events,m3.events,m4.events])

        p1 = FuncButton(name="pagefirst", callback=self.goto_page)
        p1.set_kwargs("first")
        p1.set_position((336,604))
        p2 = FuncButton(name="pageprev", callback=self.goto_page)
        p2.set_kwargs("prev")
        p2.set_position((362,604))
        p3 = FuncButton(name="pagenext", callback=self.goto_page)
        p3.set_kwargs("next")
        p3.set_position((437,604))
        p4 = FuncButton(name="pagelast", callback=self.goto_page)
        p4.set_kwargs("last")
        p4.set_position((455,604))
        self.edit_events.add([p1.events,p2.events,p3.events,p4.events])

        r1=Num(filename=DCT_INT["skip_grey"],pos=(492,607))
        r2=FuncButton(name="skiplevel", callback=self.query_skip)
        r2.set_kwargs("skip")
        r2.set_position((492,607))
        r3=FuncButton(name="clearall", callback=self.query_clear)
        r3.set_kwargs("main")
        r3.set_position((226,607))
        self.edit_events.add([r2.events,r3.events])

        self.pageimg=[Num(filename=PNUM[0],pos=(396,607)),
                      Num(filename=PNUM[1],pos=(406,607))]
        self.update_pageimg()
        self.hnum=HNum(filename=LNUM[0])
        self.hnum.highlight(0)

        files=[DCT_INT["kriss"],DCT_INT["kriss2"]]
        self.kriss=AnimatedStationary(files=files)
        self.kriss.set_position((830,18))
        self.kriss.flipticks=10
        self.sprites.add(self.kriss)

        self.errorlog=Errorlog()
        self.sprites.add([self.catbot,self.johnny,self.evilguy],1)
        self.events.add(self.edit_events)

        self.msgbg=Stationary(sprite=Image(filename=DCT_INT["msg"]))
        self.msgbg.set_position((14,408))
        self.msgbg.clear()
        self.messenger=Messenger(rect=((19,413),(780,160)))
        self.mode="edit"
        self.messenger.clear()
        self.display_tutorial()

    def load_level(self,nr=0):
        self.state="load level"
        DCT_SFX["interface_loading"].play()
        self.lvlnr=nr
        self.level=Level(nr)
        self.errorlog.reinit()
        self.still_sprites.add(self.level.animated)
        self.moving_sprites.add([self.level.flowers,self.level.crates])
        self.catbot.activate(self.level.start)
        self.counter=0
        self.sprites.add(self.moving_sprites,1)
        self.sprites.add(self.still_sprites,0)
        msgkey="lvl"+str(self.lvlnr+1)
        if DCT_MSG.has_key(msgkey):
            self.msglist=DCT_MSG[msgkey]
            self.display_message()

    def display_tutorial(self, ev=None, kwargs=None):
        if self.mode=="edit":
            self.mode="message"
            self.msgbg.prepare()
            self.msgbg.draw()
            self.messenger.gen_image(msg=DCT_MSG["tut"][0])
            b=FuncButton(name="msgnext",callback=self.display_tutorial)
            b.set_kwargs("next")
            b.set_position((772,558))
            self.events.add(b.events)
            self.query_images=[b]
            self.counter+=1

        elif self.mode=="message" and kwargs=="next":
            if self.counter < len(DCT_MSG["tut"]): #nr of tutmessages
                self.messenger.gen_image(msg=DCT_MSG["tut"][self.counter])
                self.query_images[0].draw()
            else:
                self.events.remove(self.query_events)  #clear all
                for i in self.query_images:
                    self.events.remove(i.events)
                    i.clear()
                    i.set_position((-300,-300))
                self.messenger.clear()
                self.msgbg.clear()
                self.mode="edit"
                self.load_level(self.lvlnr)

            if self.counter==2:  #nr of tut-question
                self.mode="tut-query"
                self.query_images[0].hide(1)
                yes=FuncButton(name="msgyes",callback=self.display_tutorial)
                yes.set_kwargs("yes")
                yes.set_position((669,558))
                no=FuncButton(name="msgno",callback=self.display_tutorial)
                no.set_kwargs("no")
                no.set_position((728,558))
                self.events.add([yes.events,no.events])
                self.query_buttons=[yes,no]
            if self.counter==5:
                a=Num(filename=DCT_INT["macrosplash"],pos=(184,216))
                self.query_images.append(a)
            if self.counter==6:
                self.query_images.pop().clear()
            self.counter+=1

        elif self.mode=="tut-query" and (kwargs=="yes" or kwargs=="no"):
            self.mode="message"
            self.query_images[0].hide(0)
            for i in self.query_buttons:
                self.events.remove(i.events)
                i.clear()
                i.set_position((-300,-300))
            if kwargs=="no":
                self.counter=len(DCT_MSG["tut"])-1 #nr of tutmessages
            self.display_tutorial(kwargs="next")

    def display_message(self, ev=None, kwargs=None): #normal messages
        if self.mode=="edit":
            self.mode="message"
            self.query_images=[]
            self.clear_game(1)
            self.counter=0
            self.msgbg.prepare()
            self.msgbg.draw()
            self.messenger.gen_image(self.msglist[0])
            c=FuncButton(name="msgnext",callback=self.display_message)
            c.set_kwargs("next")
            c.set_position((772,558))
            self.query_images=[c]
            self.events.add(c.events)
            #self.counter+=1

        elif self.mode=="message" and kwargs=="next":
            if self.counter < len(self.msglist):
                self.messenger.gen_image(msg=self.msglist[self.counter])
                self.query_images[0].draw()
                self.counter+=1
            else:
                self.events.remove(self.query_images[0].events)
                self.query_images[0].clear()
                self.query_images[0].hide(1)
                self.query_images=[]
                self.messenger.clear()
                self.msgbg.clear()
                self.clear_game(0)
                self.mode="edit"


        elif self.mode=="won":
            self.mode="message-won"
            self.query_images=[]
            self.clear_game(1)
            self.counter=0
            self.msgbg.draw()
            self.messenger.gen_image(self.msglist[0])
            c=FuncButton(name="msgnext",callback=self.display_message)
            c.set_kwargs("next")
            c.set_position((772,558))
            self.query_images=[c]
            self.events.add(c.events)
            self.counter+=1
        elif self.mode=="message-won" and kwargs=="next":
            if self.counter < len(self.msglist):
                self.messenger.gen_image(msg=self.msglist[self.counter])
                self.query_images[0].draw()
            else:
                self.events.remove(self.query_images[0].events)
                self.query_images[0].clear()
                self.query_images[0].hide(1)
                self.query_images=[]
                self.messenger.clear()
                self.msgbg.clear()
                self.clear_game(0)
                self.mode="edit"
                self.skip()
            self.counter+=1

    def reload_level(self):
        self.reinit()
        self.level.redraw()
        self.catbot.set_coords(self.level.start)

    def reinit(self):
        self.counter=0
        self.aborted=False
        self.wait_counter=0
        self.fullscript=[]
        self.catbot.reinit(catbot=1)
        self.johnny.reinit()
        self.evilguy.reinit()

    def skip(self, ev=None, kwargs=None):
        self.page=0
        self.lst_allLines=[]
        self.clear_lines()
        self.sprites.remove(self.moving_sprites)
        self.sprites.remove(self.still_sprites)
        self.moving_sprites.kill()
        self.still_sprites.kill()
        self.set_background(filename=DCT_INT["bg"])
        self.lvlnr+=1
        self.select()
        if self.lvlnr<len(LVL):
            self.reinit()
            self.load_level(self.lvlnr)
        elif not self.aborted and kwargs!="skipped":
            self.reinit()
            self.display_gamewon()
        else:
            self.next_state = "menu"
            self.quit=1

    def display_gamewon(self):
        self.next_state = "fin"
        self.quit=1

    def query_skip(self, ev=None, kwargs=None):
        if self.mode=="edit":
            self.mode="query"
            self.query_events.empty()
            a=Num(filename=DCT_INT["queryskip"],pos=(466,522))
            yes=FuncButton(name="yes",callback=self.query_skip)
            yes.set_kwargs("yes")
            yes.set_position((481,550,))
            no=FuncButton(name="no",callback=self.query_skip)
            no.set_kwargs("no")
            no.set_position((549,550))
            self.query_images=[a,yes,no]
            self.query_events.add([yes.events,no.events])
            self.events.add(self.query_events)
        elif self.mode=="query" and kwargs=="yes":
            self.mode="edit"
            self.events.remove(self.query_events)
            self.query_events.empty()
            while self.query_images:
                i=self.query_images.pop()  #cludge
                i.clear()
                i.set_position((-300,-300))
            self.skip(kwargs="skipped")
        elif self.mode=="query" and kwargs=="no":
            self.mode="edit"
            self.events.remove(self.query_events)
            self.query_events.empty()
            while self.query_images:
                i=self.query_images.pop()  #cludge
                i.clear()
                i.set_position((-300,-300))

    def goto_page(self,ev=None,kwargs=0):
        pages=len(self.lst_allLines)//20
        if self.inserting:
            self.uninsert()
        if kwargs=="first":
            goto=0
        elif kwargs=="prev":
            goto=(self.page-1)*20
        elif kwargs=="next":
            goto=(self.page+1)*20
        else:
            goto=pages*20
        if goto >= 0 and goto < len(self.lst_allLines):
            for i in range(20):
                nr = goto + i
                l = self.lst_lines[i]
                if nr < len(self.lst_allLines):
                    name=self.lst_allLines[nr]
                else:
                    name="empty"
                l.set_img(name)
                l.command=name
            self.page = goto//20
        self.update_pageimg()
        if self.mode=="edit":
            self.select()

    def update_pageimg(self):
        page=self.page+1
        num0 = page / 10
        num1 = page % 10
        if num0==10:
            num0=0
        self.pageimg[0].switch_sprite(Image(filename=PNUM[num0]))
        self.pageimg[1].switch_sprite(Image(filename=PNUM[num1]))

    def add_command(self, ev=None, kwargs=None):
        if self.mode=="edit":
            sel = self.selection
            real_nr=self.page*20+sel

            if self.inserting:
                l=self.lst_lines[sel]
                l.command=kwargs
                l.set_img(name=kwargs)
                self.lst_allLines[real_nr]=kwargs
                self.inserting=False

            elif sel < 20:
                l=self.lst_lines[sel]
                l.command=kwargs
                l.set_img(name=kwargs)
                if real_nr < len(self.lst_allLines):
                    self.lst_allLines[real_nr]=kwargs
                else:
                    self.lst_allLines.append(kwargs)
            else:
                lastpage=len(self.lst_allLines)//20
                self.goto_page(lastpage)
                self.select()
                sel = self.selection
                if sel >= 20:
                    self.add_page()
                    sel=0
                l=self.lst_lines[sel]
                l.command=kwargs
                l.set_img(name=kwargs)
                self.lst_allLines.append(kwargs)
                self.update_pageimg()

            self.select()
            self.inserting = False
        elif self.mode=="edit macro":
            sel = self.macro_selection
            if self.macro_inserting:
                line=self.lst_macrolines[sel]
                line.command=kwargs
                line.set_img(name=kwargs)
                self.macro[sel]=kwargs
                self.macro_inserting=False

            if sel < 10:
                l=self.lst_macrolines[sel]
                l.command=kwargs
                l.set_img(name=kwargs)
                if sel < len(self.macro):
                    self.macro[sel]=kwargs
                else:
                    self.macro.append(kwargs)
            self.select()

    def edit_macro(self, ev=None, kwargs=None):
        if self.mode=="edit":
            self.enter_macromode(kwargs=kwargs)
        elif self.mode=="edit macro" and kwargs=="save":
            self.exit_macromode(kwargs=kwargs)

    def enter_macromode(self, ev=None, kwargs=None):
        self.mode="edit macro"
        self.clear_game(1)
        self.macro=self.dct_macros[kwargs]
        a=Num(filename=DCT_INT["macrosplash"],pos=(184,216))
        b=Num(filename=DCT_INT["fadeoutfunc"],pos=(866,371))
        self.macro_images=[a,b]
        self.lst_macrolines=[]
        self.macro_inserting=False
        for i in self.macro_buttons.keys():
            self.events.remove(self.macro_buttons[i].events)

        x,y=(228,285)
        for i in range(10):
            if not i%5 and i>0:
                x=438
                y=285

            name="empty"
            if i < len(self.macro):
                name=self.macro[i]
            line = Line(name=name,callback=self.select)
            line.set_kwargs(i)
            line.set_position((x,y-3))
            self.lst_macrolines.append(line)

            e1 = EditButton(name="down", callback=self.ln_move)
            e1.set_kwargs([i, "down"])
            e1.set_position((x+103,y))
            e2 = EditButton(name="up", callback=self.ln_move)
            e2.set_kwargs([i, "up"])
            e2.set_position((x+118,y))
            e3 = EditButton(name="ins", callback=self.ln_edit)
            e3.set_kwargs([i, "ins"])
            e3.set_position((x+133,y))
            e4 = EditButton(name="del", callback=self.ln_edit)
            e4.set_kwargs([i, "del"])
            e4.set_position((x+148,y))

            events=[e1.events,e2.events,e3.events,e4.events,line.events]
            self.macro_events.add(events)
            self.macro_images.extend([line,e1,e2,e3,e4])
            y+=19

        save=FuncButton(name="macrosave", callback=self.exit_macromode)
        save.set_kwargs(kwargs)
        save.set_position((350,247))
        clear=FuncButton(name="macroclear", callback=self.query_clear)
        clear.set_kwargs("clear")
        clear.set_position((416,247))
        self.macro_events.add([save.events, clear.events])
        self.macro_images.extend([save,clear])
        self.macro_buttons[kwargs].highlight(1)
        self.events.add(self.macro_events)
        self.select()

    def exit_macromode(self, ev=None, kwargs=None):
        self.mode="edit"
        self.select()
        self.events.remove(self.macro_events)
        self.clear_game(0)
        for i in self.macro_buttons.keys():
            self.events.add(self.macro_buttons[i].events)
            self.macro_buttons[i].highlight(0)

        while self.macro_images:
            i=self.macro_images.pop()
            i.clear()
            i.set_position((-300,-300))

    def clear_game(self, bol=1):
        self.catbot.hide(bol)
        self.johnny.hide(bol)
        self.evilguy.hide(bol)
        for i in self.moving_sprites:
            i.hide(bol)
        for i in self.still_sprites:
            i.hide(bol)

    def clear_lines(self,ev=None,kwargs=None):
        lines=[]
        if kwargs=="macro":
            lst=self.macro
            lines=self.lst_macrolines
        else:
            self.page=0
            lst=self.lst_allLines
            lines=self.lst_lines

        for i in lines:
            i.set_img("empty")
            i.command="empty"
        while lst:
            lst.pop()

    def query_clear(self,ev=None,kwargs=None):
        if self.mode=="edit":
            self.mode="queryclear"
            self.query_events.empty()
            splash=Num(filename=DCT_INT["queryclear"],pos=(199,522))
            yes=FuncButton(name="yes",callback=self.query_clear)
            yes.set_kwargs("all1")
            yes.set_position((214,550))
            no=FuncButton(name="no",callback=self.query_clear)
            no.set_kwargs("all0")
            no.set_position((282,550))
            self.query_images=[splash,yes,no]
            self.query_events.add([yes.events,no.events])
            self.events.add(self.query_events)
        elif self.mode=="edit macro":
            self.mode="queryclear"
            self.query_events.empty()
            splash=Num(filename=DCT_INT["queryclearm"],pos=(317,283))
            yes=FuncButton(name="yes",callback=self.query_clear)
            yes.set_kwargs("macro1")
            yes.set_position((349,311))
            no=FuncButton(name="no",callback=self.query_clear)
            no.set_kwargs("macro0")
            no.set_position((417,311))
            self.query_images=[splash,yes,no]
            self.query_events.add([yes.events,no.events])
            self.events.add(self.query_events)
        elif self.mode=="queryclear":
            self.events.remove(self.query_events)
            self.query_events.empty()
            while self.query_images:
                i=self.query_images.pop()  #cludge
                i.clear()
                i.set_position((-300,-300))

            if kwargs.endswith("1"):
                self.clear_lines(kwargs=kwargs[:-1])

            self.mode="edit"
            if kwargs.startswith("macro"):
                self.mode="edit macro"
            else:
                self.goto_page("first")
            if self.mode=="edit":
                self.reload_level()
            self.select()



    def add_page(self, ev=None, kwargs=None):
        self.page+=1
        for i in self.lst_lines:
            i.set_img("empty")
            i.command="empty"

    def select(self, ev=None, kwargs=None):
        if self.mode=="edit":
            nr = kwargs
            sel = self.selection
            last=0
            for i in self.lst_lines:
                if i.command=="empty":
                    break
                last+=1
            if self.inserting:
                self.uninsert()
            elif nr<=last:
                if nr is None:  #select last line of code
                    self.selection=last
                elif nr==sel:
                    l=self.lst_lines[sel%20]
                    l.highlight(0)
                    self.selection=last
                elif nr <= len(self.lst_lines):
                    l=self.lst_lines[sel%20]
                    l.highlight(0)
                    l=self.lst_lines[nr]
                    l.highlight(1)
                    self.selection=nr
            self.hnum.highlight(self.selection)
        elif self.mode=="run script":
            self.hnum.highlight(kwargs%20)
        elif self.mode=="edit macro":
            nr=kwargs
            sel=self.macro_selection
            last = len(self.macro)
            if self.macro_inserting:
                self.uninsert()
            if nr is None:
                self.macro_selection=last
            elif nr==sel and self.macro[nr]!="empty":
                l=self.lst_macrolines[nr]
                l.highlight(0)
                self.macro_selection=last
            elif nr < 10:
                if sel<len(self.macro):
                    l=self.lst_macrolines[sel]
                    l.highlight(0)
                l=self.lst_macrolines[nr]
                l.highlight(1)
                self.macro_selection=nr

    def uninsert(self, ev=None, kwargs=None):
        if self.mode=="edit" and self.inserting:
            for i in range(20):
                if self.lst_lines[i].command=="empty":
                    nr= i
                    break
            real_nr=self.page*20+nr
            self.lst_allLines.pop(real_nr)  #delete line from code
            for i in range(nr, len(self.lst_lines)):#redraw vis. lines
                if self.page*20+i < len(self.lst_allLines):
                    name=self.lst_allLines[self.page*20+i]
                else:
                    name="empty"
                l=self.lst_lines[i]
                l.set_img(name)
                l.command=name
            self.inserting=False
            self.select()

        elif self.mode=="edit macro" and self.macro_inserting:
            nr=self.macro_selection
            self.macro.pop(nr)
            for i in range(10):
                name="empty"
                if i < len(self.macro):
                    name=self.macro[i]
                l=self.lst_macrolines[i]
                l.set_img(name)
                l.command=name
            self.macro_inserting=False
            self.select()

    def run_script(self, ev=None, kwargs=None):  #add line highlighting
        if self.mode=="edit":
            self.mode="run script"
            DCT_SFX["run-button"].play()
            self.waitFor(timeout=250)
            self.aborted=False
            self.reload_level()
            self.errorlog.reinit()
            self.fullscript=[]
            self.counter=0
            self.wait_counter=0
            self.goto_page(kwargs="first")
            for i in self.lst_allLines:
                if i!="fwd" and i.startswith("f"):
                    self.fullscript.extend(self.dct_macros[i])
                else:
                    self.fullscript.append(i)

    def ln_move(self, ev=None, kwargs=None):
        nr2=None
        nr, whereTo = kwargs
        if self.mode=="edit":
            real_nr=self.page*20+nr
            if real_nr < (len(self.lst_allLines)):
                if whereTo=="up" and real_nr>0:
                    nr2 = nr - 1
                    real_nr2 = real_nr - 1
                elif whereTo=="down" and real_nr<(len(self.lst_allLines)-1):
                    nr2 = nr + 1
                    real_nr2 = real_nr + 1
            if self.inserting:
                self.uninsert()
            elif nr2 is not None:
                name=self.lst_allLines[real_nr]
                name2=self.lst_allLines[real_nr2]
                self.lst_allLines[real_nr]=name2 #change code line
                self.lst_allLines[real_nr2]=name
                ln=self.lst_lines[nr]  #change visible line
                ln.set_img(name2)
                ln.command=(name2)
                if nr2 < len(self.lst_lines) and nr2 >= 0: #other line visible?
                    ln2=self.lst_lines[nr2] #then change, too
                    ln2.set_img(name)
                    ln2.command=(name)

        elif self.mode=="edit macro":
            if self.macro_inserting:
                self.uninsert()
            elif nr < len(self.macro):
                if whereTo=="up" and nr>0:
                    nr2=nr-1
                elif whereTo=="down":
                    nr2=nr+1
                if nr2 is not None:
                    name=self.macro[nr]
                    name2=self.macro[nr2]
                    self.macro[nr]=name2
                    self.macro[nr2]=name
                    ln=self.lst_macrolines[nr]
                    ln.set_img(name2)
                    ln.set_command(name2)
                    ln2=self.lst_macrolines[nr2]
                    ln2.set_img(name)
                    ln2.set_command(name)

    def ln_edit(self, ev=None, kwargs=None):
        nr, task =  kwargs
        if self.mode=="edit":
            real_nr = self.page*20+nr
            if real_nr < (len(self.lst_allLines)):
                ln = self.lst_lines[nr]
                if self.inserting:
                    self.uninsert()
                elif task=="del":
                    self.select()
                    self.lst_allLines.pop(real_nr)  #delete line from code
                    for i in range(nr, len(self.lst_lines)):#redraw vis. lines
                        name="empty"
                        if self.page*20+i < len(self.lst_allLines):
                            name=self.lst_allLines[self.page*20+i]
                        l=self.lst_lines[i]
                        l.set_img(name)
                        l.command=name
                    self.select()
                elif task=="ins":
                    ln.set_img("empty")
                    ln.command="empty"
                    self.lst_allLines.insert(real_nr,"empty")
                    self.select(real_nr)
                    for i in range(nr+1,len(self.lst_lines)):
                        name="empty"
                        if self.page*20+i < len(self.lst_allLines):
                            name=self.lst_allLines[self.page*20+i]
                        l=self.lst_lines[i]
                        l.set_img(name)
                        l.command=name
                    self.inserting = True
        elif self.mode=="edit macro":
            if nr<len(self.macro):
                if self.macro_inserting:
                    self.uninsert()
                elif task=="del" and nr<len(self.macro):
                    self.macro.pop(nr)
                    for i in range(nr, len(self.lst_macrolines)):
                        name="empty"
                        if i < len(self.macro):
                            name=self.macro[i]
                        ln=self.lst_macrolines[i]
                        ln.set_img(name)
                        ln.command=name
                    self.select()
                elif task=="ins":
                    if len(self.macro)<10:
                        ln = self.lst_macrolines[nr]
                        ln.set_img("empty")
                        ln.command="empty"
                        self.macro.insert(nr,"empty")

                        for i in range(len(self.lst_macrolines)):
                            name="empty"
                            if i<len(self.macro):
                                name=self.macro[i]
                            ln=self.lst_macrolines[i]
                            ln.set_img(name)
                            ln.command=name

                        self.select(kwargs=nr)
                        self.macro_selection=nr
                        self.macro_inserting=True

    def checkCollisions(self):  #called in every mainloop so..
        time.sleep(0.03)  # I just put that here.
        if self.mode=="run script": #and that too
            if self.catbot.collide(self.johnny) or \
               self.catbot.collide(self.evilguy):
                DCT_SFX["caught"].play()
                self.configure()

            if self.fullscript:
                if not self.catbot.moving and \
                   not self.johnny.moving and \
                   not self.evilguy.moving:
                    self.waitFor(timeout=100) #remove later?
                    cmd=self.fullscript.pop(0)

                    if self.wait_counter:
                        self.wait_counter -= 1
                    else:
                        code=self.lst_allLines[self.counter]
                        self.counter += 1
                        if code.startswith("f") and code!="fwd":
                            mlength=len(self.dct_macros[code])
                            self.wait_counter=mlength-1
                            nr=self.counter
                            self.select(kwargs=nr)
                        else:
                            nr=self.counter
                            self.select(kwargs=nr-1)
                        if not nr%20 and nr>=20:
                            self.goto_page(kwargs="next")

                    if self.cmdcheck(self.catbot,cmd):
                        self.catbot.do(cmd)
                    else:
                        self.error() #create error log

                    if self.johnny.active:
                        self.botmove(self.johnny)
                        self.botmove(self.evilguy)
            else:
                if not self.catbot.moving:
                    self.mode="edit"
                    self.select()
                    if not self.aborted and self.check_win():
                        self.mode="won"
                        DCT_SFX["levelcomplete"].play()
                        msgkey="lvl"+str(self.lvlnr+1)+"e"
                        if DCT_MSG.has_key(msgkey):
                            self.msglist=DCT_MSG[msgkey]
                        else:
                            nr=int(random.random()*len(DCT_MSG["lvle"]))
                            self.msglist=[DCT_MSG["lvle"][nr]]
                        self.display_message()


    def botmove(self,bot):
        if bot.go_fwd:
            bot.go_fwd=0
            bot.do("fwd")
        else:
            dir=LEFT
            cmd="left"
            if bot is self.evilguy:
                dir=RIGHT
                cmd="right"
            looks=bot.looks

            bot.looks=dir[bot.looks] #left side for johnny
            if self.cmdcheck(bot,"fwd"):
                bot.looks=looks
                bot.do(cmd)
                bot.go_fwd=1
                return
            bot.looks=looks  #in front of johnny
            if self.cmdcheck(bot,"fwd"):
                bot.do("fwd")
                return
            bot.looks=dir[bot.looks] #right side for johnny
            bot.looks=dir[bot.looks]
            bot.looks=dir[bot.looks]
            if self.cmdcheck(bot,"fwd"):
                bot.looks=looks
                if bot is self.johnny:
                    bot.do("right")
                else:
                    bot.do("left")
                bot.go_fwd=1
                return
            bot.looks = looks
            bot.do(cmd) # else turn around and try again

    def check_win(self):
        if not self.aborted:
            crates_placed = 0
            crates=[]
            targets=[]
            for i in self.level.animated:   #cludge
                targets.append(i.coords)
            for i in self.level.crates:
                crates.append(i.coords)
            crates.sort()
            targets.sort()
            if crates==targets:
                crates_placed=1
            no_pellets = self.level.pellets==0

            if self.catbot.coords==self.level.exit \
               and crates_placed \
               and no_pellets:
                return 1
            else:
                return 0


    def cmdcheck(self, bot, cmd):
        lvl=self.level
        if cmd=="left" or cmd=="right" or cmd=="wait":
            return 1
        x,y=bot.get_fwd()
        if cmd=="fwd":
            if lvl.map.has_key((x,y)):
                dest=lvl.map[(x,y)]
                if not LST_BLOCKING.__contains__(dest.kind) and \
                   not lvl.find_asset("crates",(x,y)) and \
                   not lvl.find_asset("flowers",(x,y)):
                        if dest.kind=="trigger" and not self.johnny.active:
                            self.evilguy.activate(self.level.start)
                            self.johnny.activate(self.level.start)
                        return 1

        if cmd=="use":
            if lvl.map.has_key((x,y)):
                dest=lvl.map[x,y]
                if dest.kind=="doorc" and bot.keys:
                    dest.switch_sprite(Image(filename=DCT_TILE["dooro"]))
                    dest.switch_kind("ground")
                    bot.keys-=1
                    DCT_SFX["dooropen"].play()
                    return 1
                if dest.kind=="trigger1":
                    dest.switch_sprite(Image(filename=DCT_TILE["trigger2"]))
                    dest.switch_kind("wall")
                    if lvl.airlock:
                        DCT_SFX["airlock"].play()
                        al = lvl.map[lvl.airlock]
                        al.switch_sprite(Image(filename=DCT_TILE["airlocko"]))
                        al.switch_kind("ground")
                    return 1
        if cmd=="push":
            if lvl.map.has_key((x,y)):
                dest=lvl.map[x,y]
                pushme=lvl.find_asset("crates",(x,y))
                if not pushme:
                    pushme=lvl.find_asset("flowers",(x,y))
                if pushme:
                    pcoords=pushme.coords
                    pdest=pushme.get_fwd(bot.looks)  #and don't push cratees over people!!
                    if lvl.map.has_key(pdest) and \
                       not LST_BLOCKING.__contains__(lvl.map[pdest].kind) and\
                       not lvl.find_asset("crates",pdest) and \
                       not lvl.find_asset("flowers",pdest):
                            pushme.moveto(bot.looks)
                            DCT_SFX["crate"].play()
                            return 1
        if cmd=="pickup":
            x,y=bot.coords
            if lvl.map.has_key((x,y)):
                dest=lvl.map[(x,y)]
                if dest.kind=="key":
                    dest.switch_sprite(Image(filename=DCT_TILE["ground"]))
                    dest.switch_kind("ground")
                    bot.add_key(1)
                    DCT_SFX["key"].play()
                    return 1
                elif dest.kind=="pellet":
                    dest.switch_sprite(Image(filename=DCT_TILE["ground"]))
                    dest.switch_kind("ground")
                    lvl.rem_pellet()
                    DCT_SFX["pellet"].play()
                    return 1
        return 0

    def error(self, msg="Unkown error in unkown entity"):
        msg="Error: page "+str(self.counter/20+1)+" line "+str(self.counter%20) + " "
        DCT_SFX["error"].play()
        print msg
        if not self.errorlog.full:
            self.errorlog.gen_image(msg)


    def configure(self, ev=None, kwargs=None):
        if self.mode=="run script":
            self.aborted=True
            self.fullscript=[]

    def show_help(self, ev=None, kwargs=None):
        if self.mode=="edit":
            self.mode="help"
            self.edit_events.disable()
            self.help_button.events.enable()
            self.query_events.empty()
            a=Stationary(sprite=Image(filename=DCT_INT["help"]))
            a.set_position((0,0))
            b=FuncButton(name="helpnext", callback=self.show_help)
            b.set_position((752,560))
            b.set_kwargs("next")
            self.clear_game(1)
            self.query_images=[a,b]
            self.query_events.add(b.events)
            self.events.add(self.query_events)

            #self.help_button.highlight(1)
            self.help_button.draw()

        elif self.mode=="help" and kwargs=="next" or kwargs=="prev":
            self.events.remove(self.query_events)
            self.query_events.empty()
            self.query_images[1].clear()
            self.query_images[1].set_position((-300,-300))
            self.query_images[0].clear()
            self.query_images=[]

            if kwargs=="next":
                bg="help2"
                bname="helpprev"
                kwargs="prev"
            else:
                bg="help"
                bname="helpnext"
                kwargs="next"
            a=Stationary(sprite=Image(filename=DCT_INT[bg]))
            a.set_position((0,0))
            b=FuncButton(name=bname, callback=self.show_help)
            b.set_position((752,560))
            b.set_kwargs(kwargs)
            self.query_images=[a,b]
            self.query_events.add(b.events)
            self.events.add(self.query_events)

            #self.help_button.highlight(1)
            self.help_button.draw()

        elif self.mode=="help" and kwargs=="menuhelp":
            self.mode="edit"
            self.events.remove(self.query_events)
            self.edit_events.enable()
            self.query_events.empty()
            self.query_images[1].clear()
            self.query_images[1].set_position((-300,-300))
            self.query_images[0].clear()
            self.query_images=[]
            self.clear_game(0)

    def togl_fullscreen(self, ev=None):
        pygame.display.toggle_fullscreen()

    def start_menu(self, ev=None, kwargs=None):
        if self.mode=="edit":
            self.mode="query"
            self.query_events.empty()
            a=Num(filename=DCT_INT["queryquit"],pos=(563,518))
            yes=FuncButton(name="yes",callback=self.start_menu)
            yes.set_kwargs(1)
            yes.set_position((627,550))
            no=FuncButton(name="no",callback=self.start_menu)
            no.set_kwargs(0)
            no.set_position((695,550))
            self.query_images=[a,yes,no]
            self.query_events.add([yes.events,no.events])
            self.events.add(self.query_events)
        elif self.mode=="query" and kwargs:
            self.next_state = "menu"
            self.quit=1
        elif self.mode=="query" and not kwargs:
            self.mode="edit"
            self.events.remove(self.query_events)
            self.query_events.empty()
            while self.query_images:
                i=self.query_images.pop()  #cludge
                i.clear()
                i.set_position((-300,-300))

    def quit_game(self, ev=None, kwargs=None):
        self.next_state = None
        self.quit=1

    def splash_screen(self):  #please do not show pygsear splash screen
        pass

    def splash_screen_poof(self):
        pass

class GameOver(Game):
    def initialize(self):
        self.next_state=None
        self.set_background(filename=DCT_INT["fin"])
        self.set_title("PW6 - C.A.T.:B.O.T. (You win!)")
        self.events.add(KEYDOWN_Event(key=K_f,callback=self.togl_fullscreen))
        self.events.add(MOUSEBUTTONUP_Event(button=1, callback=self.start_menu))

    def configure(self, ev=None):
        self.start_menu()

    def start_menu(self, ev=None):
        self.next_state="menu"
        self.quit=1

    def togl_fullscreen(self, ev=None):
        pygame.display.toggle_fullscreen()
    def quit_game(self, ev=None, kwargs=None):
        self.next_state = None
        self.quit=1

    def checkCollisions(self):  #called in every mainloop so..
        time.sleep(0.03)  # I just put that here.

    def splash_screen(self):  #please do not show pygsear splash screen
        pass

    def splash_screen_poof(self):
        pass


class Menu(Game):
    def initialize(self):
        self.next_state = None
        self.cat=CatButton(filename=DCT_INT["credits"],
                    callback=self.flipnose)
        self.set_background(color=(0,0,0))
        self.cat.set_position((-500,-500))
        self.set_title("PW6 - C.A.T.:B.O.T. (menu)")
        self.set_background(filename=DCT_INT["startbg"])
        self.events.add(KEYDOWN_Event(key=K_f,callback=self.togl_fullscreen))

        b1=FuncButton(name="titlenew", callback=self.start_game)
        b1.set_kwargs(1)
        b1.set_position((781,391))
        self.b1=b1
        b2=FuncButton(name="titleexit", callback=self.quit_game)
        b2.set_kwargs(1)
        b2.set_position((781,577))
        self.b1=b1
        b3=StationaryButton(sprite=Image(filename=DCT_INT["catnose"]),
                            callback=self.flipcat)
        b3.set_position((329,562))
        self.catnose=b3
        self.events.add([b1.events, b2.events, b3.events, self.cat.events])

    def flipcat(self,ev=None):
        self.catnose.set_position((-500,-500))
        self.cat.set_position((14,190))

    def flipnose(self, ev=None):
        self.cat.set_position((-500,-500))
        self.catnose.set_position((329,562))

    def start_game(self, ev=None, kwargs=None):
        self.next_state = "play"
        self.quit=1

    def quit_game(self, ev=None, kwargs=None):
        self.next_state = None
        self.quit=1

    def splash_screen(self):  #please do not show pygsear splash screen
        pass
    def splash_screen_poof(self):
        pass
    def togl_fullscreen(self, ev=None):
        pygame.display.toggle_fullscreen()



def main():
    state="menu"
    dct_states = {"menu":Menu, "play":Play, "fin":GameOver}
    pygame.mixer.music.load(BGM)
    pygame.mixer.music.set_volume(1.0)
    pygame.mixer.music.play(-1)
    while state:
        g=dct_states[state]()
        g.mainloop()
        state=g.next_state
        if state=="play":
            pygame.mixer.music.set_volume(0.5)
        else:
            pygame.mixer.music.set_volume(1.0)



if __name__=="__main__":
    main()

