import data, pygame

try:
    pygame.mixer.init()
except:
    pass
def load_sound(filename):
    class NoneSound:
        def play(self): pass
    if not pygame.mixer:
        return NoneSound()
    try:
        sound = pygame.mixer.Sound(filename)
    except pygame.error, message:
        print 'Cannot load sound:', filename
        return NoneSound()
    return sound

DCT_SFX={}
sfx=["airlock","caught","crate","dooropen","error","interface_loading",
"key","levelcomplete","pellet","run-button"]
for i in sfx:
    DCT_SFX[i]=load_sound(data.filepath("sfx/"+i+".ogg"))

LVL=["tutorial01.map",
    "tutorial02.map","tutorial03.map","tutorial04.map","tutorial05.map",
    "maze01.map","crates01.map","pellet01.map","vocfi01.map",
    "maze02.map","crates02.map","pellet02.map","vocfi02.map",
    "maze03.map","crates03.map","pellet03.map","vocfi03.map",
    "maze04.map","crates04.map","pellet04.map","vocfi04.map",
    "maze05.map","crates05.map","pellet05.map","vocfi05.map"]

for i in range(len(LVL)):
    LVL[i] = data.filepath("maps"+"/"+ LVL[i])

LEFT={"up":"left", "down":"right", "left":"down","right":"up"}
RIGHT={"up":"right", "down":"left", "left":"up","right":"down"}

DCT_CHARAS={}
DCT_CHARAS["catbot"]=data.filepath("charas/catbot")
DCT_CHARAS["johnny"]=data.filepath("charas/johnny")
DCT_CHARAS["evilguy"]=data.filepath("charas/evilguy")

BGM=data.filepath("catbot.xm")

PNUM = []
for i in range(10):
    PNUM.append(data.filepath("interface/numbers/pc"+str(i)+".png"))

LNUM =[]
for i in range(20):
    dings=str(i+1)
    if i+1<10:
        dings="0"+dings
    LNUM.append(data.filepath("interface/numbers/hl"+dings+".png"))

DCT_TILE={}
tiles = ["airlockc","airlocko","crate","cratetarget1","cratetarget2",
         "doorc","dooro","exit","flower","ground","key","pellet","start",
         "trigger1","trigger2","emptyness","wall","trigger",
         "wall1","wall2","wall2_2","wall3","wall4",]
for i in tiles:
    DCT_TILE[i]=data.filepath("tiles/"+i+".png")

LST_BLOCKING = ["airlockc","crate","doorc","flower","wall"]

DCT_INT={}
DCT_INT["startbg"]=data.filepath("interface/title.png")
DCT_INT["titlenew"]=data.filepath("interface/buttons/titlenew_1.png")
DCT_INT["titlenew_2"]=data.filepath("interface/buttons/titlenew_2.png")
DCT_INT["titleexit"]=data.filepath("interface/buttons/titleexit_1.png")
DCT_INT["titleexit_2"]=data.filepath("interface/buttons/titleexit_2.png")
DCT_INT["catnose"]=data.filepath("interface/buttons/catbotnose.png")
DCT_INT["credits"]=data.filepath("interface/buttons/credits.png")

DCT_INT["fin"]=data.filepath("interface/fin.png")
DCT_INT["help"]=data.filepath("interface/help1.png")
DCT_INT["help2"]=data.filepath("interface/help2.png")
DCT_INT["msg"]=data.filepath("interface/messagescreen.png")
DCT_INT["msgnext"]=data.filepath("interface/buttons/msgnext_1.png")
DCT_INT["msgnext_2"]=data.filepath("interface/buttons/msgnext_2.png")
DCT_INT["msgno"]=data.filepath("interface/buttons/msgno_1.png")
DCT_INT["msgno_2"]=data.filepath("interface/buttons/msgno_2.png")
DCT_INT["msgyes"]=data.filepath("interface/buttons/msgyes_1.png")
DCT_INT["msgyes_2"]=data.filepath("interface/buttons/msgyes_2.png")

DCT_INT["helpnext"]=data.filepath("interface/buttons/helpnext_1.png")
DCT_INT["helpnext_2"]=data.filepath("interface/buttons/helpnext_2.png")
DCT_INT["helpprev"]=data.filepath("interface/buttons/helpprev_1.png")
DCT_INT["helpprev_2"]=data.filepath("interface/buttons/helpprev_2.png")

DCT_INT["bg"]=data.filepath("interface/interface.png")
DCT_INT["empty"]=data.filepath("interface/buttons/empty.png")
DCT_INT["yes"]=data.filepath("interface/buttons/yes_1.png")
DCT_INT["yes_2"]=data.filepath("interface/buttons/yes_2.png")
DCT_INT["no"]=data.filepath("interface/buttons/no_1.png")
DCT_INT["no_2"]=data.filepath("interface/buttons/no_2.png")
DCT_INT["queryquit"]=data.filepath("interface/queryquit.png")
DCT_INT["kriss"]=data.filepath("interface/kriss1.png")
DCT_INT["kriss2"]=data.filepath("interface/kriss2.png")

path=data.filepath("interface/macrosplash")+"/"
DCT_INT["macrosplash"]=path+"macrosplash.png"
DCT_INT["fadeoutfunc"]=path+"fadeoutfunc.png"
DCT_INT["macroclear"]=path+"macroclear_1.png"
DCT_INT["macroclear_2"]=path+"macroclear_2.png"
DCT_INT["macrosave"]=path+"macrosave_1.png"
DCT_INT["macrosave_2"]=path+"macrosave_2.png"
DCT_INT["queryclearm"]=path+"queryclearm.png"

DCT_INT["clearall"]=data.filepath("interface/buttons/clearall_1.png")
DCT_INT["clearall_2"]=data.filepath("interface/buttons/clearall_2.png")
DCT_INT["skiplevel"]=data.filepath("interface/buttons/skiplevel_1.png")
DCT_INT["skiplevel_2"]=data.filepath("interface/buttons/skiplevel_2.png")
DCT_INT["skip_grey"]=data.filepath("interface/buttons/skiplevel_inactive.png")
DCT_INT["queryclear"]=data.filepath("interface/querycleara.png")
DCT_INT["queryskip"]=data.filepath("interface/macrosplash/queryskip.png")

cmds=["pagefirst","pagelast","pagenext","pageprev",
      "menuexit","menuhelp","menurun","menustop"]
for i in cmds:
    DCT_INT[i]=data.filepath("interface/buttons/"+i+"_1.png")
    DCT_INT[i+"_2"]=data.filepath("interface/buttons/"+i+"_2.png")

cmds=["fwd","left","right","pickup","push","use","wait"]
for i in cmds:
    DCT_INT[i]=data.filepath("interface/buttons/fb"+i+"_1.png")
    DCT_INT[i+"_2"]=data.filepath("interface/buttons/fb"+i+"_2.png")

for i in xrange(9):
    nr=str(i+1)
    DCT_INT["f"+nr]=data.filepath("interface/buttons/fbfunc0"+nr+"_1.png")
    DCT_INT["f"+nr+"_2"]=data.filepath("interface/buttons/fbfunc0"+nr+"_2.png")
DCT_INT["f10"]=data.filepath("interface/buttons/fbfunc10_1.png")
DCT_INT["f10_2"]=data.filepath("interface/buttons/fbfunc10_2.png")

DCT_INT["del"]=data.filepath("interface/buttons/editdel_1.png")
DCT_INT["del_2"]=data.filepath("interface/buttons/editdel_2.png")
DCT_INT["down"]=data.filepath("interface/buttons/editdown_1.png")
DCT_INT["down_2"]=data.filepath("interface/buttons/editdown_2.png")
DCT_INT["ins"]=data.filepath("interface/buttons/editinsert_1.png")
DCT_INT["ins_2"]=data.filepath("interface/buttons/editinsert_2.png")
DCT_INT["up"]=data.filepath("interface/buttons/editup_1.png")
DCT_INT["up_2"]=data.filepath("interface/buttons/editup_2.png")

DCT_CHAR2NAME={".":"emptyness","A":"airlockc", "B":"trigger1",
                "C":"crate",    "D":"doorc",    "E":"exit",
                "F":"flower",   "G":"ground",   "K":"key",
                "P":"pellet",   "S":"start",    "T":"trigger",
                "W":"wall","X":"cratetarget1"
               }

def coord2pos(coord):
    return (coord[0]*32+24,coord[1]*32+24)
